import { createFileSystemReader } from '@previewjs/vfs';
import pino from 'pino';
import PinoPretty from 'pino-pretty';

const { pino: createLogger } = pino;
const { default: prettyLogger } = PinoPretty;
function factoryWithDefaultOptions(factory) {
  return (options) => factory({
    ...options,
    reader: options.reader || createFileSystemReader(),
    logger: options.logger || createLogger({ level: "debug" }, prettyLogger({ colorize: true }))
  });
}

export { factoryWithDefaultOptions };
